local BeneCastButton = BeneCast.Button;

function BeneCastButton:Resize(buttonsize)

	local button, buttonborder, buttoncooldown, buttonfade, buttonrange
	-- Set Button height and width to buttonsize
	self:SetHeight(buttonsize);
	self:SetWidth(buttonsize);
	buttonborder = self.NormalTexture;
	-- Set the Button border to fit around the button
	buttonborder:SetHeight(buttonsize * 2 - (buttonsize/36) * 10);
	buttonborder:SetWidth(buttonsize * 2 - (buttonsize/36) * 10);
	buttoncooldown = self.Cooldown;
	-- Set Cooldown size
	buttoncooldown:SetScale((buttonsize / 36));
	buttoncooldown:SetPoint('CENTER', button, 'CENTER');
	buttonfade = self.Fade;
	-- Set Fade size
	buttonfade:SetHeight(buttonsize * 2 - (buttonsize/36) * 10);
	buttonfade:SetWidth(buttonsize * 2 - (buttonsize/36) * 10);
	buttonrange = self.Range;
	-- Set Range size
	buttonrange:SetHeight(buttonsize);
	buttonrange:SetWidth(buttonsize);

end

function BeneCastButton:GetButtonFromOld()

	local button;
	local len = table.maxn(wv.OldButtons);
	if len > 0 then
		button = wv.OldButtons[len];
		table.remove(wv.OldButtons);
	end
	return button;
	
end

function BeneCastButton:NewButton(panel, prevbutton)

	local seqno = prevbutton.seqno;
	if seqno == nil then
		seqno = 1;
	else
		seqno = seqno + 1;
	end
	local buttonname = 'BeneCastButton_' .. pfid .. '_' .. unit .. '_' .. seqno;
	local button = self:GetButtonFromOld();
	if not button then
		button = CreateFrame('Button', buttonname , UIParent, 'BeneCastButtonTemplate');
		button.NormalTexture = getglobal(buttonname .. 'NormalTexture');
		button.Cooldown = getglobal(buttonname .. 'Cooldown');
		button.Fade = getglobal(buttonname .. 'Fade');
		button.Range = getglobal(buttonname .. 'Range');
		button.Duration = getglobal(buttonname .. 'Duration');
		button.Resize = self.Resize;
		button:SetFrameStrata('LOW');
	else
		button:SetName(buttonname);
		button.NormalTexture:SetName(buttonname .. 'NormalTexture');
		button.Cooldown:SetName(buttonname .. 'Cooldown');
		button.Fade:SetName(buttonname .. 'Fade');
		button.Range:SetName(buttonname .. 'Range');
		button.Duration:SetName(buttonname .. 'Duration');
	end
	button.pf = panel.pf;
	button.unit = panel.unit;
	button.seqno = seqno;
	button:SetAttribute('unit',button.unit);
	button:Hide();
	return button;
end
